/**********************************************************************************************************************************************************
Copyright 2014, Christine Largeron, Universit Jean Monnet.
Licensed under the GNU General Public License V3
 
This file is part of DANC_Generator.
http://perso.univ-st-etienne.fr/largeron/DANC_Generator/.

DANC_Generator is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DANC_Generator is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with DANC_Generator.  If not, see <http://www.gnu.org/licenses/>.

If you publish material based on DANC_Generator, then, please note the assistance you received by using this project.
Use the following reference for referring to this project:
Generating Attributed Networks with Communities by Christine Largeron, Pierre-Nicolas Mougel, Reihaneh Rabbany and Osmar R. Zaane published in PLOS ONE.
**********************************************************************************************************************************************************/

package gui.components

import java.awt.FlowLayout
import javax.swing.JPanel
import java.awt.Graphics
import java.awt.Color
import javax.swing.JLabel
import java.awt.BorderLayout
import sun.font.EAttribute
import java.awt.Font
import java.awt.Dimension
import java.awt.Graphics2D
import java.awt.RenderingHints
import java.awt.BasicStroke
import java.awt.GradientPaint
import guidyn.components.RunPanel

class TitledSeparator(title : String) extends JPanel(new BorderLayout) {
    
	add(new Painter(), BorderLayout.CENTER)
	class Painter() extends JPanel {
	    val baseColor = new Color(65,65,65)
	    val lightColor = new Color(237,237,237)
	    val leftWidth = 5
	    override def paint(g: Graphics) = {
	        val g2d = g.asInstanceOf[Graphics2D]
	        g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_LCD_HRGB)
	        val f = g2d.getFont().deriveFont(Font.BOLD, 14)
	        g2d.setFont(f)
	        g2d.setStroke(new BasicStroke(1))
	        val titleWidth = g2d.getFontMetrics(f).stringWidth(title)
	        val h = 17
	        g2d.setPaint(new GradientPaint(0, 0, lightColor, 5 + leftWidth, 0, baseColor))
	        g2d.drawLine(5, h, 5 + leftWidth, h)
	        g2d.setColor(baseColor)
	        g2d.drawString(title, 10 + leftWidth, h + 5)
	        g2d.setPaint(new GradientPaint(25 + titleWidth, 0, baseColor, getWidth() - 5, 0, lightColor))
	        g2d.drawLine(leftWidth + 15 + titleWidth, h, getWidth() - 5, h)
	    }
	    
	    // override def getPreferredSize() = new Dimension(getWidth(), 44)
	    override def getPreferredSize() = new Dimension(0, 30)
	}
}

