/**********************************************************************************************************************************************************
Copyright 2014, Christine Largeron, Universit Jean Monnet.
Licensed under the GNU General Public License V3
 
This file is part of DANC_Generator.
http://perso.univ-st-etienne.fr/largeron/DANC_Generator/.

DANC_Generator is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DANC_Generator is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with DANC_Generator.  If not, see <http://www.gnu.org/licenses/>.

If you publish material based on DANC_Generator, then, please note the assistance you received by using this project.
Use the following reference for referring to this project:
Generating Attributed Networks with Communities by Christine Largeron, Pierre-Nicolas Mougel, Reihaneh Rabbany and Osmar R. Zaane published in PLOS ONE.
**********************************************************************************************************************************************************/

package guidyn.components

import javax.swing.JPanel
import com.alee.extended.progress.WebStepProgress
import java.awt.Dimension
import javax.swing.JProgressBar
import java.awt.FlowLayout
import javax.swing.JLabel

object ProgressBar extends JPanel(new FlowLayout(FlowLayout.LEFT)) {
	val timestamp = new JLabel("Press Run to generate a new graph")
	var currentTimestamp = 0
//	timestamp.setMargin(0)
//    timestamp.setMinimumSize(new Dimension(800,600))
    
    val progressBar = new JProgressBar(0, 20)
    val progressAction = new JLabel("")
    
	add(timestamp)
	add(progressBar)
	add(progressAction)
	
    def generateNewGraph(nbTimestamps : Int) {
	    currentTimestamp = 1
	    timestamp.setText("Timestamp " + currentTimestamp)
	}
	
	def nextTimestamp() = {
	    currentTimestamp += 1
	    timestamp.setText("Timestamp " + currentTimestamp)
	}
	
	def startTask(label : String, maxValue : Option[Int] = None) {
	    progressAction.setText(label)
	    if(maxValue.isDefined) {
	        progressBar.setIndeterminate(false)
	        progressBar.setMaximum(maxValue.get)
	    } else {
	        progressBar.setIndeterminate(true)
	    }
	}
	
	def allDone() = {
	    progressAction.setText("")
	    timestamp.setText("Graph generated")
	    progressBar.setIndeterminate(false)
	    progressBar.setMaximum(1)
	    progressBar.setValue(1)
	}
	
	def taskAdvance(step : Int = 1) {
	    progressBar.setValue(progressBar.getValue() + step)
	}
}