/**********************************************************************************************************************************************************
Copyright 2014, Christine Largeron, Universit Jean Monnet.
Licensed under the GNU General Public License V3
 
This file is part of DANC_Generator.
http://perso.univ-st-etienne.fr/largeron/DANC_Generator/.

DANC_Generator is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DANC_Generator is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with DANC_Generator.  If not, see <http://www.gnu.org/licenses/>.

If you publish material based on DANC_Generator, then, please note the assistance you received by using this project.
Use the following reference for referring to this project:
Generating Attributed Networks with Communities by Christine Largeron, Pierre-Nicolas Mougel, Reihaneh Rabbany and Osmar R. Zaane published in PLOS ONE.
**********************************************************************************************************************************************************/

package guidyn.components.graph

import javax.swing.JSplitPane
import gui.components.Savable
import gui.components.SavableManager
import javax.swing.JPanel
import guidyn.components.VerticalLayout
import java.awt.BorderLayout

object GraphPanel extends JPanel(new BorderLayout()) with Savable {
	val optionPanel = new JPanel(new VerticalLayout(5, VerticalLayout.BOTH, VerticalLayout.TOP))
	optionPanel.add(GraphViewOption)
	optionPanel.add(GraphLayoutOption)
	optionPanel.add(VertexSizeOption)
	optionPanel.add(SelectVerticesOption)
	val splitPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, GraphView, optionPanel)
	
    add(TimestampSelection, BorderLayout.NORTH)
    add(splitPanel, BorderLayout.CENTER)
    
    override def save() = SavableManager.save("graphPanelSplitPosition", splitPanel.getDividerLocation()) 
    override def load() = splitPanel.setDividerLocation(SavableManager.load("graphPanelSplitPosition", 250))
}
