/**********************************************************************************************************************************************************
Copyright 2014, Christine Largeron, Universit Jean Monnet.
Licensed under the GNU General Public License V3
 
This file is part of DANC_Generator.
http://perso.univ-st-etienne.fr/largeron/DANC_Generator/.

DANC_Generator is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DANC_Generator is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with DANC_Generator.  If not, see <http://www.gnu.org/licenses/>.

If you publish material based on DANC_Generator, then, please note the assistance you received by using this project.
Use the following reference for referring to this project:
Generating Attributed Networks with Communities by Christine Largeron, Pierre-Nicolas Mougel, Reihaneh Rabbany and Osmar R. Zaane published in PLOS ONE.
**********************************************************************************************************************************************************/

package guidyn.components.graph

import guidyn.components.CollapsablePanel
import java.awt.BorderLayout
import javax.swing.JPanel
import com.alee.extended.label.WebHotkeyLabel
import gui.components.SpinSlider
import com.alee.laf.combobox.WebComboBox
import guidyn.components.listeners.TimestampUpdateListener
import algo.structures.Graph
import utils.SwingEvents._
import guidyn.components.listeners.GraphUpdateListener
import algo.structures.DynamicGraph
import javax.swing.JLabel
import javax.swing.JCheckBox
import javax.swing.JComboBox
import scala.collection.mutable.HashMap
import java.awt.FlowLayout
import gui.components.Savable
import gui.components.SavableManager
import utils.Icon
import javax.swing.JButton

object SelectVerticesOption extends CollapsablePanel("Select Vertices") {
    
//    val vertexEventsCheckBoxes = HashMap[VertexEvent, JCheckBox]()
    val displayAllVerticesButton = new JButton("Display all Vertices", Icon.get("eye"))
    displayAllVerticesButton.onAction { e =>
        GraphView.setHiddenVertices({ v => false })
    }
    addComponent(displayAllVerticesButton)
    
    for(e <- VertexEvents.allProperties) {
        val actionsPanel = new JPanel(new FlowLayout(FlowLayout.LEFT))
        val selectButton = new JButton(Icon.get("crosshair"))
        val displayButton = new JButton(Icon.get("eye"))
        actionsPanel.add(selectButton)
        actionsPanel.add(displayButton)
        actionsPanel.add(new JLabel(e.name))
        
        selectButton.onAction { event =>
            GraphView.setSelectedVertices({ v =>
                if(GraphView.curDynamicGraph.isDefined) {
                    val curVertexEvents = GraphView.curDynamicGraph.get.graphs(GraphView.curTimestamp).vertexEvents
                    if(curVertexEvents.contains(v)) {
                        curVertexEvents(v).contains(e)
                    } else { false }
                } else { false }
            })
        }
        
        displayButton.onAction { event =>
            GraphView.setHiddenVertices({ v =>
                if(GraphView.curDynamicGraph.isDefined) {
                    val curVertexEvents = GraphView.curDynamicGraph.get.graphs(GraphView.curTimestamp).vertexEvents
                    if(curVertexEvents.contains(v)) {
                        !curVertexEvents(v).contains(e)
                    } else { true }
                } else { true }
            })
        }
        
        /*
        val checkBox = new JCheckBox(e.name)
        checkBox.onAction { e => GraphView.repaint() }
        vertexEventsCheckBoxes(e) = checkBox
        val checkBoxPanel = new JPanel(new FlowLayout(FlowLayout.LEFT))
        checkBoxPanel.add(checkBox)
        * 
        */
        addComponent(actionsPanel)
    }
    
    /*
    def isVertexInSelection(v : Int, graph : Graph) : Boolean = {
        vertexEventsCheckBoxes.exists { a => a._2.isSelected() && graph.vertexEvents(v).contains(a._1) }
    }
    */
    /*
    override def save() {
        super.save()
        for(e <- VertexEvents.allProperties) { SavableManager.save("selectedVertexProperty" + e.name, vertexEventsCheckBoxes(e).isSelected()) }
        
    }
    override def load() {
        super.load()
        for(e <- VertexEvents.allProperties) { vertexEventsCheckBoxes(e).setSelected(SavableManager.load("selectedVertexProperty" + e.name, true)) }
    } 
    */
}

