/**********************************************************************************************************************************************************
Copyright 2014, Christine Largeron, Universit Jean Monnet.
Licensed under the GNU General Public License V3
 
This file is part of DANC_Generator.
http://perso.univ-st-etienne.fr/largeron/DANC_Generator/.

DANC_Generator is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DANC_Generator is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with DANC_Generator.  If not, see <http://www.gnu.org/licenses/>.

If you publish material based on DANC_Generator, then, please note the assistance you received by using this project.
Use the following reference for referring to this project:
Generating Attributed Networks with Communities by Christine Largeron, Pierre-Nicolas Mougel, Reihaneh Rabbany and Osmar R. Zaane published in PLOS ONE.
**********************************************************************************************************************************************************/

package guidyn.components.graph

import java.awt.Color

object VertexEvents {
	val createVertex = VertexEvent("Created", Color.decode("#8ae234"))
	val removeVertex = VertexEvent("Removed", Color.decode("#ef2929"))
	val attributesUpdated = VertexEvent("Attributes updated", Color.decode("#fce94f"))
	val singleTimestamp = VertexEvent("Single timestamp", Color.decode("#729fcf"))
	val noChanges = VertexEvent("No changes", Color.decode("#eeeeec"))
	val leaderForCommunitySplit = VertexEvent("Community split leader", Color.decode("#ad7fa8"))
	
	val leaderForCommunityMigrate = VertexEvent("Community migration leader", Color.decode("#2e3436"))
	val migratingVertices = VertexEvent("Migrating vertices", Color.decode("#888a85"))
	
	val allProperties = Array(noChanges, createVertex, removeVertex, attributesUpdated, singleTimestamp, leaderForCommunitySplit, leaderForCommunityMigrate, migratingVertices)
}

case class VertexEvent(name : String, color : Color)