/**********************************************************************************************************************************************************
Copyright 2014, Christine Largeron, Universit Jean Monnet.
Licensed under the GNU General Public License V3
 
This file is part of DANC_Generator.
http://perso.univ-st-etienne.fr/largeron/DANC_Generator/.

DANC_Generator is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DANC_Generator is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with DANC_Generator.  If not, see <http://www.gnu.org/licenses/>.

If you publish material based on DANC_Generator, then, please note the assistance you received by using this project.
Use the following reference for referring to this project:
Generating Attributed Networks with Communities by Christine Largeron, Pierre-Nicolas Mougel, Reihaneh Rabbany and Osmar R. Zaane published in PLOS ONE.
**********************************************************************************************************************************************************/

package scalargs.argtypes

/**
 * Created by IntelliJ IDEA.
 * User: nico
 * Date: 19 juin 2010
 * Time: 11:42:17
 * To change this template use File | Settings | File Templates.
 */

class DoubleArg(
        name : String,
        names : List[String] = List(),
        help : String = "",
        default : Double = 0,
        choices : List[String] = List(),
        metaVar : String = "ARG",
        group : String = "",
        showDefault : Boolean = true,
        showParams : Boolean = true) extends ArgType(name, names, help, choices, 1, 0, metaVar, group, showDefault, showParams) {

    def getVal() : Double = {
        if (!isSet) {
            return default
        }
        try {
            return params.head.toDouble
        } catch {
            case e:NumberFormatException => {}
        }
        return default
    }
}